#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

const char *gdata[BUFSIZ] = {
    "     0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f",
    "00:          -- -- -- -- -- -- -- -- -- -- -- -- --",
    "10: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --",
    "20: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --",
    "30: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --",
    "40: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --",
    "50: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --",
    "60: -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --",
    "70: -- -- -- -- -- -- -- --",
    NULL
};
const char fname[] = "/tmp/i2cdetect.log";

static void
striptail(char *s)
{
    char    *p;

    p = s + strlen(s) - 1;
    while (p >= s && (isspace(*p) || *p == 0x0A)) {
        *p-- = '\0';
    }
}

void
strip_hyphen(char *s)
{
    char *p;

    while ((p = strchr(s, '-')) != NULL) {
        *p = ' ';
    }
}

int
magic()
{
    FILE    *fp;
    char    cmd[BUFSIZ];
    char    buf[BUFSIZ];
    char    tmp[BUFSIZ];
    int     i;

    sprintf(cmd, "i2cdetect -y 0 > %s", fname);
    system(cmd);

    if ((fp = fopen(fname, "r")) == NULL) {
        return -1;
    }
    for (i = 0; gdata[i] != NULL; i++) {
        fgets(buf, BUFSIZ, fp);
        striptail(buf);
        strcpy(tmp, gdata[i]);

        strip_hyphen(buf);
        strip_hyphen(tmp);

        if (strcmp(buf, tmp) != 0) {
            return  1;
        }
    }
    fclose(fp);
    unlink(fname);

    return  -1;
}
